%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Created_PSet_ID = DB_PSet_Create_Bush(Pset_Name, Ori_Coord_ID, K1, K2, K3, K4, K5, K6, Elm_list)

global db_Next_PSet_Number;
global ErrCode;

global DB_PSETS;

global AST_PSETS;
global AST_COORD;

global AT_PSETS;
global AT_COORD;

global AT_Page_Prealloc_Size;

Created_PSet_ID = [];

Elm_list = unique(Elm_list);

if (isempty(Elm_list))
    Elm_list = [];
end

% Проверка существования в базе property set со следующим номером
if (DB_PSet_Exist(db_Next_PSet_Number))
    fprintf (1, '\nОшибка функции DB_PSet_Create_Bush: property set с номером %i уже существует в базе !\n', db_Next_PSet_Number);
    ErrCode = -1;
    return;
end

% Првоерка имени property set
if (isempty(Pset_Name))
    fprintf (1, '\nОшибка функции DB_PSet_Create_Bush: задано пустое имя property set !\n');
    ErrCode = -1;
    return;
end

% Проверка существования в базе системы координат
if (~isempty(Ori_Coord_ID))
    if (Ori_Coord_ID ~= 0)
        if (~DB_Coord_Exist(Ori_Coord_ID))
            fprintf (1, '\nОшибка функции DB_PSet_Create_Bush: система координат с номером %i отсутствует в базе !\n', Ori_Coord_ID);
            ErrCode = -1;
            return;
        end
    end
end

% Проверка значений
if (K1 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Create_Bush: недопустимое значение переменной K1 [%e] !\n', K1);
    ErrCode = -1;
    return;
end

if (K2 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Create_Bush: недопустимое значение переменной K2 [%e] !\n', K2);
    ErrCode = -1;
    return;
end

if (K3 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Create_Bush: недопустимое значение переменной K3 [%e] !\n', K3);
    ErrCode = -1;
    return;
end

if (K4 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Create_Bush: недопустимое значение переменной K4 [%e] !\n', K4);
    ErrCode = -1;
    return;
end

if (K5 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Create_Bush: недопустимое значение переменной K5 [%e] !\n', K5);
    ErrCode = -1;
    return;
end

if (K6 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Create_Bush: недопустимое значение переменной K6 [%e] !\n', K6);
    ErrCode = -1;
    return;
end

% Задание значений по умолчанию
if (isempty(Ori_Coord_ID))
    Ori_Coord_ID = 0;
end

if (isempty(K1))
    K1 = 0;
end

if (isempty(K2))
    K2 = 0;
end

if (isempty(K3))
    K3 = 0;
end

if (isempty(K4))
    K4 = 0;
end

if (isempty(K5))
    K5 = 0;
end

if (isempty(K6))
    K6 = 0;
end

% Выделение памяти
if (isempty(DB_PSETS))
    AT_PSETS = zeros(AT_Page_Prealloc_Size,1,'uint64');
end
if (db_Next_PSet_Number >= size(AT_PSETS,1))
    AT_PSETS(db_Next_PSet_Number + AT_Page_Prealloc_Size,1) = 0;
end

% Следующий индекс в базе
Next_DB_index = size(DB_PSETS,1) + 1;

% Создание записи в базе
DB_PSETS{Next_DB_index,1}.type = 'PBUSH';
DB_PSETS{Next_DB_index,1}.ID = db_Next_PSet_Number;
DB_PSETS{Next_DB_index,1}.Patran_name = Pset_Name;
DB_PSETS{Next_DB_index,1}.K = zeros(6,1);
DB_PSETS{Next_DB_index,1}.K(1) = K1;
DB_PSETS{Next_DB_index,1}.K(2) = K2;
DB_PSETS{Next_DB_index,1}.K(3) = K3;
DB_PSETS{Next_DB_index,1}.K(4) = K4;
DB_PSETS{Next_DB_index,1}.K(5) = K5;
DB_PSETS{Next_DB_index,1}.K(6) = K6;
DB_PSETS{Next_DB_index,1}.Ori_CID_Field_ID = DB_Field_Create(1);
if (ErrCode < 0)
    return;
end

% Задание значения по умолчанию для поля Ori_CID_Field_ID
DB_Field_Add_Record(DB_PSETS{Next_DB_index,1}.Ori_CID_Field_ID, 1, Ori_Coord_ID);
if (ErrCode < 0)
    return;
end

% Создание записи в таблице ассоциативности property set
AST_PSETS{Next_DB_index,1}.Elm_list = [];

% Внесение изменений в таблицу ассоциативности систем координат
if (Ori_Coord_ID > 0)
    AST_COORD{AT_COORD(Ori_Coord_ID)}.PSet_list = Union_Column(AST_COORD{AT_COORD(Ori_Coord_ID)}.PSet_list, db_Next_PSet_Number);
end

% Создание ссылки в адресной таблице
AT_PSETS(db_Next_PSet_Number) = Next_DB_index;

% Номер созданного property set
Created_PSet_ID = db_Next_PSet_Number;

% Изменение счетчика
db_Next_PSet_Number = db_Next_PSet_Number + 1;

% Ассоциирование элементов с созданным property set
if (~isempty(Elm_list))
    DB_Elm_Modify_Pset(Elm_list, Created_PSet_ID);
end
